Index: /trunk/lib/Validator.inc.php
===================================================================
--- /trunk/lib/Validator.inc.php	(revision 467)
+++ /trunk/lib/Validator.inc.php	(revision 468)
@@ -31,20 +31,25 @@
  */
 
-// Known credit card types.
-define('CC_TYPE_VISA', 1);
-define('CC_TYPE_MASTERCARD', 2);
-define('CC_TYPE_AMEX', 3);
-define('CC_TYPE_DISCOVER', 4);
-define('CC_TYPE_DINERS', 5);
-define('CC_TYPE_JCB', 6);
-
-// validateEmail return types.
-define('VALIDATE_EMAIL_SUCCESS', 0);
-define('VALIDATE_EMAIL_REGEX_FAIL', 1);
-define('VALIDATE_EMAIL_LENGTH_FAIL', 2);
-define('VALIDATE_EMAIL_MX_FAIL', 3);
-
 class Validator {
 
+    // Known credit card types.
+    const CC_TYPE_VISA = 1;
+    const CC_TYPE_MASTERCARD = 2;
+    const CC_TYPE_AMEX = 3;
+    const CC_TYPE_DISCOVER = 4;
+    const CC_TYPE_DINERS = 5;
+    const CC_TYPE_JCB = 6;
+
+    // Validator::validateEmail() return types.
+    const EMAIL_SUCCESS = 0;
+    const EMAIL_REGEX_FAIL = 1;
+    const EMAIL_LENGTH_FAIL = 2;
+    const EMAIL_MX_FAIL = 3;
+
+    // Validator::validatePhone() return types.
+    const PHONE_SUCCESS = 0;
+    const PHONE_REGEX_FAIL = 1;
+    const PHONE_LENGTH_FAIL = 2;
+
     /**
      * Ensures a value is empty.
@@ -53,5 +58,5 @@
      * @return bool   true if form is not empty, false otherwise.
      */
-    function notEmpty($val)
+    static public function notEmpty($val)
     {
         return '' != trim((string)$val);
@@ -64,5 +69,5 @@
      * @return bool   true if form is empty, false otherwise.
      */
-    function isEmpty($val)
+    static public function isEmpty($val)
     {
         return '' == trim((string)$val);
@@ -75,5 +80,5 @@
      * @return bool   true if form is a string, false otherwise.
      */
-    function isString($val)
+    static public function isString($val)
     {
         return '' == trim((string)$val) || is_string($val);
@@ -86,5 +91,5 @@
      * @return bool   True if no errors found, false otherwise.
      */
-    function isNumber($val)
+    static public function isNumber($val)
     {
         return '' == trim((string)$val) || is_numeric($val);
@@ -98,5 +103,5 @@
      * @return bool   true if value is an integer
      */
-    function isInteger($val, $negative_ok=false)
+    static public function isInteger($val, $negative_ok=false)
     {
         $pattern = $negative_ok ? '/^-?[[:digit:]]+$/' : '/^[[:digit:]]+$/';
@@ -112,5 +117,5 @@
      * @return bool   true if value is a float
      */
-    function isFloat($val, $negative_ok=false)
+    static public function isFloat($val, $negative_ok=false)
     {
         $pattern = $negative_ok ? '/^-?[[:digit:]]*(?:\.?[[:digit:]]+)$/' : '/^[[:digit:]]*(?:\.?[[:digit:]]+)$/';
@@ -124,5 +129,5 @@
      * @return bool   true if value is a float
      */
-    function isArray($val)
+    static public function isArray($val)
     {
         return (is_string($val) && '' == trim((string)$val)) || is_array($val);
@@ -138,5 +143,5 @@
      * @return bool   true if value passes regex test
      */
-    function checkRegex($val, $regex, $valid_on_match=true)
+    static public function checkRegex($val, $regex, $valid_on_match=true)
     {
         return $valid_on_match ? preg_match($regex, $val) : !preg_match($regex, $val);
@@ -151,5 +156,5 @@
      * @return bool   true if string length is within given boundaries
      */
-    function stringLength($val, $min, $max)
+    static public function stringLength($val, $min, $max)
     {
         return mb_strlen(trim((string)$val)) >= $min && mb_strlen($val) <= $max;
@@ -164,5 +169,5 @@
      * @return bool   True if no errors found, false otherwise.
      */
-    function numericRange($val, $min, $max)
+    static public function numericRange($val, $min, $max)
     {
         return '' == trim((string)$val) || (is_numeric($val) && $val >= $min && $val <= $max);
@@ -180,8 +185,9 @@
      * @access  public
      * @param   string  $val    The input data to validate..
-     * @return  const           One of the constant values: VALIDATE_EMAIL_SUCCESS|VALIDATE_EMAIL_REGEX_FAIL|VALIDATE_EMAIL_LENGTH_FAIL|VALIDATE_EMAIL_MX_FAIL
+     * @param   bool    $strict Do we run strict tests?
+     * @return  const           One of the constant values: Validate::EMAIL_SUCCESS|Validate::EMAIL_REGEX_FAIL|Validate::EMAIL_LENGTH_FAIL|Validate::EMAIL_MX_FAIL
      * @author  Quinn Comendant <quinn@strangecode.com>
      */
-    function validateEmail($val)
+    static public function validateEmail($val, $strict=false)
     {
         require_once 'codebase/lib/Email.inc.php';
@@ -190,5 +196,5 @@
         // Test email address format.
         if (!preg_match($e->getParam('regex'), $val, $e_parts)) {
-            return VALIDATE_EMAIL_REGEX_FAIL;
+            return self::EMAIL_REGEX_FAIL;
         }
 
@@ -203,15 +209,35 @@
         // Test length.
         if (mb_strlen($local) > 64 || mb_strlen($domain) > 191) {
-            return VALIDATE_EMAIL_LENGTH_FAIL;
-        }
-
-        // Check domain exists: It's a domain if ip2long fails; Checkdnsrr ensures a MX record exists; Gethostbyname() ensures the domain exists.
-        // Compare ip2long twice for php4 backwards compat.
-        if ((ip2long($domain) == '-1' || ip2long($domain) === false) && function_exists('checkdnsrr') && !checkdnsrr($domain . '.', 'MX') && gethostbyname($domain) == $domain) {
-            // FIXME: Do we care?
-            // return VALIDATE_EMAIL_MX_FAIL;
-        }
-
-        return VALIDATE_EMAIL_SUCCESS;
+            return self::EMAIL_LENGTH_FAIL;
+        }
+
+        // Strict tests below.
+
+        // Check domain exists: It's a domain if ip2long fails; checkdnsrr ensures a MX record exists; gethostbyname() ensures the domain exists.
+        if ($strict && ip2long($domain) === false && function_exists('checkdnsrr') && !checkdnsrr($domain . '.', 'MX') && gethostbyname($domain) == $domain) {
+            return self::EMAIL_MX_FAIL;
+        }
+
+        return self::EMAIL_SUCCESS;
+    }
+
+    /**
+     * Check whether input is a valid phone number. Notice: it is now set
+     * to allow characters like - or () or + so people can type in a phone
+     * number that looks like: +1 (530) 555-1212
+     *
+     * @param  string  $form_name the name of the incoming form variable
+     *
+     * @return bool    true if no errors found, false otherwise
+     */
+    static public function validatePhone($val)
+    {
+        if (!self::checkRegex($val, '/^[0-9 +().-]*$/', true)) {
+            return self::PHONE_REGEX_FAIL;
+        }
+        if (!self::stringLength($val, 0, 25)) {
+            return self::PHONE_LENGTH_FAIL;
+        }
+        return self::PHONE_SUCCESS;
     }
 
@@ -223,8 +249,6 @@
      * @return bool    True if no errors found, false otherwise.
      */
-    function validateStrDate($val)
-    {
-		$app =& App::getInstance();
-
+    static public function validateStrDate($val)
+    {
 		if (is_string($val) && '' === trim($val)) {
 		    // Don't be too bothered about empty strings.
@@ -249,66 +273,66 @@
      * @return bool    True if no errors found, false otherwise.
      */
-     function validateCCNumber($val, $cc_type=null)
-     {
-         // Get rid of any non-digits
-         $cc_num = preg_replace('/[^\d]/', '', $val);
-
-         // Perform card-specific checks, if applicable
-         switch ($cc_type) {
-             case CC_TYPE_VISA :
-                 $regex = '/^4\d{15}$|^4\d{12}$/';
-                 break;
-             case CC_TYPE_MASTERCARD :
-                 $regex = '/^5[1-5]\d{14}$/';
-                 break;
-             case CC_TYPE_AMEX :
-                 $regex = '/^3[47]\d{13}$/';
-                 break;
-             case CC_TYPE_DISCOVER :
-                 $regex = '/^6011\d{12}$/';
-                 break;
-             case CC_TYPE_DINERS :
-                 $regex = '/^30[0-5]\d{11}$|^3[68]\d{12}$/';
-                 break;
-             case CC_TYPE_JCB :
-                 $regex = '/^3\d{15}$|^2131|1800\d{11}$/';
-                 break;
-             default :
-                 $regex = '';
-                 break;
-         }
-
-         if ('' != $regex && !preg_match($regex, $cc_num)) {
-             // Invalid format.
-             return false;
-         }
-
-         // The Luhn formula works right to left, so reverse the number.
-         $cc_num = strrev($cc_num);
-
-         $luhn_total = 0;
-
-         $num = mb_strlen($cc_num);
-         for ($i=0; $i<$num; $i++) {
-             // Get each digit.
-             $digit = mb_substr($cc_num, $i, 1);
-
-             //  If it's an odd digit, double it.
-             if ($i / 2 != floor($i / 2)) {
-                 $digit *= 2;
-             }
-
-             //  If the result is two digits, add them.
-             if (mb_strlen($digit) == 2) {
-                 $digit = mb_substr($digit, 0, 1) + mb_substr($digit, 1, 1);
-             }
-
-             //  Add the current digit to the $luhn_total.
-             $luhn_total += $digit;
-         }
-
-         // If the Total is evenly divisible by 10, it's cool!
-         return $luhn_total % 10 == 0;
-     }
+    static public function validateCCNumber($val, $cc_type=null)
+    {
+        // Get rid of any non-digits
+        $cc_num = preg_replace('/[^\d]/', '', $val);
+
+        // Perform card-specific checks, if applicable
+        switch ($cc_type) {
+        case self::CC_TYPE_VISA :
+            $regex = '/^4\d{15}$|^4\d{12}$/';
+            break;
+        case self::CC_TYPE_MASTERCARD :
+            $regex = '/^5[1-5]\d{14}$/';
+            break;
+        case self::CC_TYPE_AMEX :
+            $regex = '/^3[47]\d{13}$/';
+            break;
+        case self::CC_TYPE_DISCOVER :
+            $regex = '/^6011\d{12}$/';
+            break;
+        case self::CC_TYPE_DINERS :
+            $regex = '/^30[0-5]\d{11}$|^3[68]\d{12}$/';
+            break;
+        case self::CC_TYPE_JCB :
+            $regex = '/^3\d{15}$|^2131|1800\d{11}$/';
+            break;
+        default :
+            $regex = '';
+            break;
+        }
+
+        if ('' != $regex && !preg_match($regex, $cc_num)) {
+            // Invalid format.
+            return false;
+        }
+
+        // The Luhn formula works right to left, so reverse the number.
+        $cc_num = strrev($cc_num);
+
+        $luhn_total = 0;
+
+        $num = mb_strlen($cc_num);
+        for ($i=0; $i<$num; $i++) {
+            // Get each digit.
+            $digit = mb_substr($cc_num, $i, 1);
+
+            //  If it's an odd digit, double it.
+            if ($i / 2 != floor($i / 2)) {
+                $digit *= 2;
+            }
+
+            //  If the result is two digits, add them.
+            if (mb_strlen($digit) == 2) {
+                $digit = mb_substr($digit, 0, 1) + mb_substr($digit, 1, 1);
+            }
+
+            //  Add the current digit to the $luhn_total.
+            $luhn_total += $digit;
+        }
+
+        // If the Total is evenly divisible by 10, it's cool!
+        return $luhn_total % 10 == 0;
+    }
 
     /**
@@ -318,5 +342,5 @@
      * @return bool   True if no errors found, false otherwise.
      */
-    function fileUploaded($form_name)
+    static public function fileUploaded($form_name)
     {
         if (!isset($_FILES[$form_name]['name']) || empty($_FILES[$form_name]['name'])) {
@@ -341,3 +365,2 @@
 } // THE END
 
-?>
Index: /trunk/lib/Version.inc.php
===================================================================
--- /trunk/lib/Version.inc.php	(revision 467)
+++ /trunk/lib/Version.inc.php	(revision 468)
@@ -4,5 +4,5 @@
  * For details visit the project site: <http://trac.strangecode.com/codebase/>
  * Copyright 2001-2012 Strangecode, LLC
- * 
+ *
  * This file is part of The Strangecode Codebase.
  *
@@ -11,10 +11,10 @@
  * Free Software Foundation, either version 3 of the License, or (at your option)
  * any later version.
- * 
+ *
  * The Strangecode Codebase is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
  * details.
- * 
+ *
  * You should have received a copy of the GNU General Public License along with
  * The Strangecode Codebase. If not, see <http://www.gnu.org/licenses/>.
@@ -39,11 +39,14 @@
 class Version {
 
+    // A place to keep an object instance for the singleton pattern.
+    private static $instance = null;
+
     // Configuration of this object.
-    var $_params = array(
+    private $_params = array(
         'max_qty' => 100, // Never have more than this many versions of each record.
         'min_qty' => 25, // Keep at least this many versions of each record.
         'min_days' => 7, // Keep ALL versions within this many days, even if MORE than min_qty.
         'db_table' => 'version_tbl',
-        
+
         // Automatically create table and verify columns. Better set to false after site launch.
         // This value is overwritten by the $app->getParam('db_create_tables') setting if it is available.
@@ -54,5 +57,5 @@
 
     // Auth_SQL object from which to access a current user_id.
-    var $_auth;
+    private $_auth;
 
     /**
@@ -63,13 +66,11 @@
      * @static
      */
-    static function &getInstance($auth_object)
-    {
-        static $instance = null;
-
-        if ($instance === null) {
-            $instance = new Version($auth_object);
-        }
-
-        return $instance;
+    public static function &getInstance($auth_object)
+    {
+        if (self::$instance === null) {
+            self::$instance = new self($auth_object);
+        }
+
+        return self::$instance;
     }
 
@@ -79,5 +80,5 @@
      * @param mixed  $auth_object  An Auth_SQL object.
      */
-    function Version($auth_object)
+    public function __construct($auth_object)
     {
 		$app =& App::getInstance();
@@ -102,5 +103,5 @@
      * @since   26 Aug 2005 17:09:36
      */
-    function initDB($recreate_db=false)
+    public function initDB($recreate_db=false)
     {
 		$app =& App::getInstance();
@@ -155,5 +156,5 @@
      * @param  array $params   Array of param keys and values to set.
      */
-    function setParam($params=null)
+    public function setParam($params=null)
     {
         if (isset($params) && is_array($params)) {
@@ -170,8 +171,8 @@
      * @return mixed               Configured parameter value.
      */
-    function getParam($param)
+    public function getParam($param)
     {
 		$app =& App::getInstance();
-    
+
         if (isset($this->_params[$param])) {
             return $this->_params[$param];
@@ -192,5 +193,5 @@
      * @return int                  The id for the version (mysql last insert id).
      */
-    function create($record_table, $record_key, $record_val, $title='', $notes='')
+    public function create($record_table, $record_key, $record_val, $title='', $notes='')
     {
 		$app =& App::getInstance();
@@ -204,5 +205,5 @@
             return false;
         }
-        
+
         // Get previous version_number.
         $qid = $db->query("
@@ -253,5 +254,5 @@
      * @return int                  The id for the version (mysql last insert id).
      */
-    function restore($version_id)
+    public function restore($version_id)
     {
 		$app =& App::getInstance();
@@ -314,8 +315,8 @@
      * @return mixed                Array of versions, or false if none.
      */
-    function deleteOld($record_table, $record_key, $record_val)
-    {
-		$db =& DB::getInstance();
-	
+    public function deleteOld($record_table, $record_key, $record_val)
+    {
+		$db =& DB::getInstance();
+
         $this->initDB();
 
@@ -381,13 +382,13 @@
      * @return mixed                Array of versions, or false if none.
      */
-    function getList($record_table, $record_key, $record_val)
-    {
-		$db =& DB::getInstance();
-	
+    public function getList($record_table, $record_key, $record_val)
+    {
+		$db =& DB::getInstance();
+
         $this->initDB();
 
         // Get versions of this record.
         $qid = $db->query("
-            SELECT 
+            SELECT
                 version_id,
                 saved_by_user_id,
@@ -418,8 +419,8 @@
      * @return mixed                Array of data saved in version, or false if none.
      */
-    function getVerson($version_id)
-    {
-		$db =& DB::getInstance();
-	
+    public function getVerson($version_id)
+    {
+		$db =& DB::getInstance();
+
         $this->initDB();
 
@@ -439,8 +440,8 @@
      * @return mixed                Array of data saved in version, or false if none.
      */
-    function getData($version_id)
-    {
-		$db =& DB::getInstance();
-	
+    public function getData($version_id)
+    {
+		$db =& DB::getInstance();
+
         $this->initDB();
 
@@ -465,8 +466,8 @@
      * @return mixed                Array of data saved in version, or false if none.
      */
-    function getCurrent($record_table, $record_key, $record_val)
-    {
-		$db =& DB::getInstance();
-	
+    public function getCurrent($record_table, $record_key, $record_val)
+    {
+		$db =& DB::getInstance();
+
         $this->initDB();
 
@@ -484,3 +485,2 @@
 
 } // End of class.
-?>
Index: /trunk/services/admins.php
===================================================================
--- /trunk/services/admins.php	(revision 467)
+++ /trunk/services/admins.php	(revision 468)
@@ -55,5 +55,5 @@
 
 // Configure the cache object.
-$cache = new Cache('admins');
+$cache =& Cache::getInstance('admins');
 $cache->setParam(array('enabled' => false)); // Better leave disabled; the list gets out of sync with the db otherwise, somehow.
 
@@ -552,3 +552,2 @@
 }
 
-?>
Index: /trunk/services/css.php
===================================================================
--- /trunk/services/css.php	(revision 467)
+++ /trunk/services/css.php	(revision 468)
@@ -36,3 +36,2 @@
 }
 
-?>
Index: /trunk/services/lock.php
===================================================================
--- /trunk/services/lock.php	(revision 467)
+++ /trunk/services/lock.php	(revision 468)
@@ -4,5 +4,5 @@
  * For details visit the project site: <http://trac.strangecode.com/codebase/>
  * Copyright 2001-2012 Strangecode, LLC
- * 
+ *
  * This file is part of The Strangecode Codebase.
  *
@@ -11,10 +11,10 @@
  * Free Software Foundation, either version 3 of the License, or (at your option)
  * any later version.
- * 
+ *
  * The Strangecode Codebase is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
  * details.
- * 
+ *
  * You should have received a copy of the GNU General Public License along with
  * The Strangecode Codebase. If not, see <http://www.gnu.org/licenses/>.
@@ -69,3 +69,2 @@
 include 'footer.ihtml';
 
-?>
Index: /trunk/services/login.php
===================================================================
--- /trunk/services/login.php	(revision 467)
+++ /trunk/services/login.php	(revision 468)
@@ -36,10 +36,7 @@
 $login_prefs->setDefaults(array('username' => ''));
 
-if ('' != $login_prefs->get('username')) {
-    $frm['remember_me'] = '1';
-}
-
 $frm['username'] = getFormdata('username', $login_prefs->get('username'));
 $frm['password'] = getFormdata('password');
+$frm['remember_me'] = ('' != $login_prefs->get('username')) ? '1' : '';
 
 if (getFormdata('username', false)) {
@@ -69,3 +66,2 @@
 include 'footer.ihtml';
 
-?>
Index: /trunk/services/logout.php
===================================================================
--- /trunk/services/logout.php	(revision 467)
+++ /trunk/services/logout.php	(revision 468)
@@ -38,3 +38,2 @@
 $app->dieURL($app->getParam('redirect_home_url'));
 
-?>
Index: /trunk/services/logs.php
===================================================================
--- /trunk/services/logs.php	(revision 467)
+++ /trunk/services/logs.php	(revision 468)
@@ -293,3 +293,2 @@
 
 
-?>
Index: /trunk/services/password.php
===================================================================
--- /trunk/services/password.php	(revision 467)
+++ /trunk/services/password.php	(revision 468)
@@ -87,3 +87,2 @@
 include 'footer.ihtml';
 
-?>
Index: /trunk/services/phpinfo.php
===================================================================
--- /trunk/services/phpinfo.php	(revision 467)
+++ /trunk/services/phpinfo.php	(revision 468)
@@ -38,3 +38,2 @@
 ?><h1>$_SERVER dump</h1><?php
 dump($_SERVER,1);
-?>
Index: /trunk/services/reset_password.php
===================================================================
--- /trunk/services/reset_password.php	(revision 467)
+++ /trunk/services/reset_password.php	(revision 468)
@@ -87,3 +87,2 @@
 include 'footer.ihtml';
 
-?>
Index: /trunk/services/versions.php
===================================================================
--- /trunk/services/versions.php	(revision 467)
+++ /trunk/services/versions.php	(revision 468)
@@ -136,3 +136,2 @@
 include 'footer.ihtml';
 
-?>
Index: /trunk/tests/AppTest.php
===================================================================
--- /trunk/tests/AppTest.php	(revision 467)
+++ /trunk/tests/AppTest.php	(revision 468)
@@ -4,5 +4,5 @@
  * For details visit the project site: <http://trac.strangecode.com/codebase/>
  * Copyright 2001-2012 Strangecode, LLC
- * 
+ *
  * This file is part of The Strangecode Codebase.
  *
@@ -11,10 +11,10 @@
  * Free Software Foundation, either version 3 of the License, or (at your option)
  * any later version.
- * 
+ *
  * The Strangecode Codebase is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
  * details.
- * 
+ *
  * You should have received a copy of the GNU General Public License along with
  * The Strangecode Codebase. If not, see <http://www.gnu.org/licenses/>.
@@ -30,13 +30,10 @@
  * Created with PHPUnit_Skeleton on 2005-08-09
  */
-require_once 'PHPUnit.php';
-class AppTest extends PHPUnit_TestCase {
+
+class AppTest extends PHPUnit_Framework_TestCase {
 
     var $App;
 
-    function AppTest($name)
-    {
-        $this->PHPUnit_TestCase($name);
-    }
+    static $shared_session;
 
     function setUp()
@@ -44,4 +41,5 @@
         require dirname(__FILE__) . '/_config.inc.php';
         $this->App =& $app;
+        $_SESSION = AppTest::$shared_session;
     }
 
@@ -49,4 +47,5 @@
     {
         unset($this->App);
+        AppTest::$shared_session = $_SESSION;
     }
 
@@ -62,10 +61,13 @@
             'test_config_value' => 1234
         ));
-        $this->assertTrue(1234 === $this->App->_params['test_config_value']);
+        $this->assertTrue(1234 === $this->App->getParam('test_config_value'));
     }
 
     function test_getParam()
     {
-        $this->App->_params['test_config_value2'] = 'okay';
+        //$this->App->setParam('test_config_value2', 'okay');
+        $this->App->setParam(array(
+            'test_config_value2' => 'okay'
+        ));
         $result = $this->App->getParam('test_config_value2');
         $this->assertEquals('okay', $result);
@@ -93,5 +95,5 @@
     {
 		$db =& DB::getInstance();
-	
+
         $qid = $db->query("SELECT 2 + 2");
         list($result) = mysql_fetch_row($qid);
@@ -104,5 +106,5 @@
         $expected = 'My message';
         $app->raiseMsg($expected, MSG_NOTICE, __FILE__, __LINE__);
-        $msg = current($_SESSION['_app'][$this->App->_ns]['messages']);
+        $msg = current($_SESSION['_app']['testapp']['messages']);
         $this->assertEquals($expected, $msg['message']);
     }
@@ -111,4 +113,5 @@
     {
         ob_start();
+        $this->test_raisemsg();  //had to add this line for phpunit ver. 3.7 ///
         $app =& App::getInstance();
         $app->printraisedmessages();
@@ -205,6 +208,7 @@
 }
 // Running the test.
+/*
 $suite = new PHPUnit_TestSuite('AppTest');
 $result = PHPUnit::run($suite);
 echo $result->toString();
-?>
+ */
Index: /trunk/tests/AuthFileTest.php
===================================================================
--- /trunk/tests/AuthFileTest.php	(revision 468)
+++ /trunk/tests/AuthFileTest.php	(revision 468)
@@ -0,0 +1,116 @@
+<?php
+/**
+ * The Strangecode Codebase - a general application development framework for PHP
+ * For details visit the project site: <http://trac.strangecode.com/codebase/>
+ * Copyright 2001-2012 Strangecode, LLC
+ * 
+ * This file is part of The Strangecode Codebase.
+ *
+ * The Strangecode Codebase is free software: you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as published by the
+ * Free Software Foundation, either version 3 of the License, or (at your option)
+ * any later version.
+ * 
+ * The Strangecode Codebase is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
+ * details.
+ * 
+ * You should have received a copy of the GNU General Public License along with
+ * The Strangecode Codebase. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/**
+ * PHPUnit test case for codebase/lib/AuthFile.inc.php
+ *
+ * The method skeletons below need to be filled in with
+ * real data so that the tests will run correctly. Replace
+ * all EXPECTED_VAL and PARAM strings with real data.
+ *
+ * Created with PHPUnit_Skeleton on 2005-08-09
+ */
+//
+class AuthFileTest extends PHPUnit_Framework_TestCase {
+
+    var $AuthFile;
+    
+    static $shared_session;
+
+    function setUp()
+    {
+        require dirname(__FILE__) . '/_config.inc.php';
+        require_once '../lib/Auth_File.inc.php';
+        $this->AuthFile = new Auth_File('test_auth');
+        $this->AuthFile->setParam(array('htpasswd_file' => dirname(__FILE__) . '/_test_htpasswd'));
+        $_SESSION = AuthFileTest::$shared_session;
+    }
+
+    function tearDown()
+    {
+        unset($this->AuthFile);
+        AuthFileTest::$shared_session = $_SESSION;
+    }
+
+    function test_authenticate()
+    {
+        $true = $this->AuthFile->authenticate('testuser', 'testpass');
+        $this->assertTrue($true, 'testuser not authorized with good password.');
+
+        $false = $this->AuthFile->authenticate('testuser', 'wrongpass');
+        $this->assertFalse($false, 'testuser not blocked with bad password.');
+    }
+
+    function test_login()
+    {
+        $result = $this->AuthFile->login('testuser', 'testpass');
+        $this->assertTrue($result, 'testuser login failed.');
+        $this->assertTrue($_SESSION['_auth_file']['test_auth']['authenticated'], 'testuser authentication not found in session.');
+    }
+
+    function test_clear()
+    {
+        $result = $this->AuthFile->login('testuser', 'testpass');
+        $this->AuthFile->clear();
+        $this->assertFalse($_SESSION['_auth_file']['test_auth']['authenticated'], 'testuser authentication not false in session.');
+    }
+
+    function test_isloggedin()
+    {
+        $this->AuthFile->login('testuser', 'testpass');
+        $true = $this->AuthFile->isloggedin();
+        $this->assertTrue($true, 'testuser not logged in but should be.');
+
+        $this->AuthFile->clear();
+        $false = $this->AuthFile->isloggedin();
+        $this->assertFalse($false, 'testuser is logged in but shouldn\'t be.');
+    }
+
+//     function test_isadmin()
+//     {
+//         $this->AuthFile->login('testuser', 'testpass');
+//         $true = $this->AuthFile->isadmin();
+//         $this->assertTrue($true);
+//     }
+//
+//     function test_requireadminlogin()
+//     {
+//         $result = $this->AuthFile->requireadminlogin(PARAM);
+//         $expected = EXPECTED_VAL;
+//         $this->assertEquals($expected, $result);
+//     }
+//
+//     function test__encrypt()
+//     {
+//         $result = $this->AuthFile->_encrypt(PARAM);
+//         $expected = EXPECTED_VAL;
+//         $this->assertEquals($expected, $result);
+//     }
+//
+//     function test__salt()
+//     {
+//         $result = $this->AuthFile->_salt(PARAM);
+//         $expected = EXPECTED_VAL;
+//         $this->assertEquals($expected, $result);
+//     }
+
+}
